/*
 * ******************************************************************************************
 *
 * File		: apb_uart_dev.h
 * Author	: GOWIN
 * Function	: Device definition of APB UART
 *
 * ******************************************************************************************
 */


// Includes ---------------------------------------------------------------------------------
#include "apb_uart_dev.h"
#include "apb_uart_driver.h"


// Definitions  -----------------------------------------------------------------------------

APB_UART_CAPABILITIES apb_uart1_get_capabilities (void)
{
	return apb_uart_get_capabilities (&apb_uart1_resources);
}

int apb_uart1_initialize (APB_UART_SignalEvent_t cb_event)
{
	return apb_uart_initialize (cb_event, &apb_uart1_resources);
}

int apb_uart1_uninitialize (void)
{
	return apb_uart_uninitialize(&apb_uart1_resources);
}

int apb_uart1_power_control (APB_UART_POWER_STATE state)
{
	return apb_uart_power_control (state, &apb_uart1_resources);
}

int apb_uart1_send (const void *data, unsigned int num)
{
	return apb_uart_send (data, num, &apb_uart1_resources);
}

int apb_uart1_receive (void *data, unsigned int num)
{
	return apb_uart_receive (data, num, &apb_uart1_resources);
}

int apb_uart1_transfer (const void *data_out, void *data_in, unsigned int num)
{
	return apb_uart_transfer (data_out, data_in, num, &apb_uart1_resources);
}

unsigned int apb_uart1_get_txcount (void)
{
	return apb_uart_get_txcount (&apb_uart1_resources);
}

unsigned int apb_uart1_get_rxcount (void)
{
	return apb_uart_get_rxcount (&apb_uart1_resources);
}

int apb_uart1_control (unsigned int control, unsigned int arg)
{
	return apb_uart_control (control, arg, &apb_uart1_resources);
}

APB_UART_STATUS apb_uart1_get_status (void)
{
	return apb_uart_get_status (&apb_uart1_resources);
}

int apb_uart1_set_modem_control (APB_UART_MODEM_CONTROL control)
{
	return apb_uart_set_modem_control (control, &apb_uart1_resources);
}

APB_UART_MODEM_STATUS apb_uart1_get_modem_status (void)
{
	return apb_uart_get_modem_status (&apb_uart1_resources);
}

#if (APB_UART1_DMA_EN == 1)
void apb_uart1_dma_tx_event (unsigned int event)
{
	apb_uart_dma_tx_event(event, &apb_uart1_resources);
}

void apb_uart1_dma_rx_event (unsigned int event)
{
	apb_uart_dma_rx_event(event, &apb_uart1_resources);
}
#endif

void apb_uart1_irq_handler (void)
{
	apb_uart_irq_handler (&apb_uart1_resources);
}
